// This is Average.C file
#include "Average.h"
#include "System.h"
extern System* My;

real *Average::val = new real[Max_N];

void Average::init()
{
  NSamp = 0;
  //double loop over i&j computes composite index(ij)
  for (int i=0; i<N; i++)  Avg[i]=0;
}

void Average::increment()
{
  //accumulates val into Avg and Avg2
  NSamp++;
  for (int i=0; i<N; i++)
   { 
     Avg[i] += val[i]; 
     //My->Avgout.precision(8);
     //if(i == 3) My->Avgout<<" "<<val[i]<<" ";
    }
}

void Average::normalize()
{
  //divide out number of samples
  for (int i=0; i<N; i++)
   { Avg[i] /= NSamp; }
}

void Average::WriteandInit()
{
  //My = new System();
  normalize();
  for (int i=0; i<N; i++)
  {
   My->Avgout.precision(8);
   //if(i ==3) My->Avgout<<" "<<Avg[i]<<" "; 
   My->Avgout<<" "<<Avg[i]<<" ";
   }
  init();
}


