//this is MVector.C file

#include "MVector.h"

using namespace std;
#include <iostream>
real rand1(); // defined in Rando.cpp

MVector MVector::RandomMVector(void)
{
  return MVector ( rand1(), rand1(), rand1());
}

void 
MVector::set_to_random_unit_MVector(void)
{
  for(int i=0 ; i<VDIMENSION;i++)
    val[i] = rand1()-0.5;
}

void 
MVector::set_to_random(const MVector& size)
{
  for(int i=0 ; i<VDIMENSION;i++)
    val[i] = size.val[i]*(rand1()-0.5);

  //val[0] =0.;
  //val[2] =0.;

//   for(int i=0 ; i<VDIMENSION;i++)
//     val[i] =0.;
//   val[0] = size.val[0]*(rand1()-0.5);

}

void 
MVector::print(const char *title) const
{
  cout<< title <<"= (";
  cout.precision(6);
  cout.setf(ios::right);
  cout<< val[0];
  for(int i=1 ; i<VDIMENSION;i++)
    cout<< ", "<<val[i];
  cout<< ")";
  cout<<endl;
}

void
MVector::print(ofstream& fstrm, char *title) const
{
  fstrm<<title<<"=(" <<val[0];
  fstrm<<", " <<val[1];
  fstrm<<", " <<val[2];
  fstrm<<")"<<endl;
}

// void 
// MVector::print_MVector(ostream& fout) const
// {
//   fout<< val[0] ;
//   for(int i=1 ; i<VDIMENSION;i++)
//     fout<< ", "<<val[i];
// }

// ostream operators

ostream& operator<< (ostream& fout, const MVector& v) {
//    fout<<"("<< v.val[0] ;
//    for(int i=1 ; i<VDIMENSION;i++)
//      fout<< ", "<<v.val[i];
//    fout<<")";
  fout<<" "<<v.val[0]<<" "<<v.val[1]<<" "<<v.val[2];
  return fout;
}

/*
istream& operator>> (istream& fin, MVector& v) {
//    fout<<"("<< v.val[0] ;
//    for(int i=1 ; i<VDIMENSION;i++)
//      fout<< ", "<<v.val[i];
//    fout<<")";
  char c1,c2;
  fin>>c1>>v.val[0]>>v.val[1]>>v.val[2]>>c2;
  assert(c1 == '(');
  assert(c2 == ')');
  return fin;
}
*/
istream& operator>> (istream& fin, MVector& v) {
  fin>>v.val[0]>>v.val[1]>>v.val[2];
  return fin;
}

ostream& MVector::iv_print(ostream& fout) const{
  fout<<" "<<val[0]<<"  "<<val[1]<<"  "<<val[2]<<" ";
  return fout;
}

/////////////////////////////////
