#include "types.h"
#include "MVector.h"
#include <fstream>
// #include <unistd.h> // for exit
class PulsedField
{
 public:
    int PulseType;  // 1:Trapezoidal, 2:Exponential
    real StartTime;
    real RiseTime;
    real FallTime;
    real PeakTime;
    real TotalTime;
    MVector Hmax;

    // member functions 
    void Read(ifstream *File);
    real RiseFunction(real t);
    real FallFunction(real t);
    MVector GetValue(real time);
};

