// file utility.h
#ifndef _UTILITY_H_ 
#define _UTILITY_H_
// higher level than types.h, lower than all else
//project includes
#include "types.h"
// #include "MVector.h" // lower level?
#include <fstream>

class PowerLaw // really power law plus constant
{	public:
	real exponent;
	real constant;
	real coef; // Diff is high-low
	inline void SetCoef(real Diff, real x) 
		{coef=Diff/pow(x,exponent);}
	// value = constant + coef * x^exponent
	inline real value(real x) {return constant+coef*pow(x,exponent);}
	// friend ostream& operator<< (ostream&, const PowerLaw&); 
	// perhaps must be in utility.cpp?:
//    inline ostream& operator<< (ostream& fout, const PowerLaw& p) {
//		fout<<"PowerLaw = "<<p.constant<<"+"<<p.coef<<"^"<<p.exponent<<endl;
//		return fout;}
}; // end class
#endif //_UTILITY_H_
